//---------------------------------------------------------------------------

#include <vcl.h>
#include <stdio.h>
#pragma hdrstop

#define String AnsiString
#include "UnitMem.h"
#include "UnitM.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFormMem *FormMem;
#include "h.h"
//---------------------------------------------------------------------------
__fastcall TFormMem::TFormMem(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TFormMem::Button1Click(TObject *Sender)
{
if(FormM->Timer2->Enabled)return;		//    
if(RadioButton1->Checked)ReadMemoryZU(0x0000, 0x4000, 64);	//  FLASH
if(RadioButton2->Checked)ReadMemoryZU(0x4000, 0x0400, 64);  //  EEPROM
if(RadioButton3->Checked)ReadMemoryZU(0x4400, 0x0800, 64);	//  SRAM
if(RadioButton4->Checked)ReadMemoryZU(0x0000, 0x4C00, 64);  //  
Memo1DblClick(NULL);
}
//---------------------------------------------------------------------------
void __fastcall TFormMem::RadioButton1Click(TObject *Sender)
{
Memo1DblClick(NULL);
}
//---------------------------------------------------------------------------
void __fastcall TFormMem::Memo1DblClick(TObject *Sender)
{
WORD X1, X2;
Memo1->Visible=false;
Memo1->Clear();                        //   
if(RadioButton1->Checked){X1=0x0000; X2=0x4000;} //   FLASH  
if(RadioButton2->Checked){X1=0x4000; X2=0x4400;} //   EEPROM  
if(RadioButton3->Checked){X1=0x4400; X2=0x4C00;} //   SRAM  
if(RadioButton4->Checked){X1=0x0000; X2=0x4C00;} //     
for(int i=X1; i<X2; i+=16)             //   
  {
  String ss=" ";                       //     
  String s=HexToStr(i);                //       
  for(int j=0; j<16; j++)              //      
	{
	s+=" "+IntToHex(Mega[i+j]);        //    
	BYTE c=Mega[i+j];                  //  
	if(c>9)ss+=String(char(c));        //  >9 
	else ss+=".";                      //  <9  
	}
//  AnsiToOem(ss.c_str(), ss.c_str()); //        
  Memo1->Lines->Add(s+ss);             //     
  }
Memo1->Visible=true;
}
//---------------------------------------------------------------------------
//   FLASH EEPROM SRAM     
void __fastcall TFormMem::Button2Click(TObject *Sender)
{
if(FormM->Timer2->Enabled)return;		//    
FileToMega(DirBin+"BIN\\fes.bin", 0, 0x4C00);
Memo1DblClick(NULL);
}
//---------------------------------------------------------------------------
//  FLASH EEPROM SRAM  
void __fastcall TFormMem::Button3Click(TObject *Sender)
{
if(FormM->Timer2->Enabled)return;		//    
MegaToFile(DirBin+"BIN\\fes.bin", 0, 0x4C00);
}
//---------------------------------------------------------------------------
void __fastcall TFormMem::FormShow(TObject *Sender)
{
Memo1DblClick(NULL);
}
//---------------------------------------------------------------------------

