//---------------------------------------------------------------------------

#include <vcl.h>
#include <stdio.h>
#include <math.h>
#pragma hdrstop

#define String AnsiString
#include "UnitReg.h"
#include "UnitIN.h"
#include "UnitM.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "Chart"
#pragma link "Series"
#pragma link "TeEngine"
#pragma link "TeeProcs"
#pragma resource "*.dfm"
TFormReg *FormReg;
#include "h.h"
int CurLn;
bool fEditFormReg;
int chrtL, chrtT, chrtW, chrtH;
int CurBoxIndex;
//---------------------------------------------------------------------------
__fastcall TFormReg::TFormReg(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
//   
void __fastcall TFormReg::FormShow(TObject *Sender)
{
CurBoxIndex=0;
chrtL=Chart1->Left;
chrtT=Chart1->Top;
chrtW=Chart1->Width;
chrtH=Chart1->Height;
ComboBox1->ItemIndex=0;
PrnGrid(0);
Application->CreateForm(__classid(TFormIN), &FormIN);
bool f; StringGrid1SelectCell(NULL, 1, 1, f);
Button4->Click();
Button5->Click();
fEditFormReg=false;
}
//---------------------------------------------------------------------------
void __fastcall TFormReg::ComboBox1Change(TObject *Sender)
{
if(fEditFormReg)
  {
  if(ID_YES==MessageBox(FormM->Handle, "  a, b, c.  ?", "!!!", MB_YESNO|MB_ICONWARNING))
  SaveABC(CurBoxIndex);
  }
CurBoxIndex=ComboBox1->ItemIndex;
PrnGrid(CurBoxIndex);
bool f; StringGrid1SelectCell(NULL, 1, 1, f);
Button4->Click();
Button5->Click();
fEditFormReg=false;
}
//---------------------------------------------------------------------------
void __fastcall TFormReg::FormClose(TObject *Sender, TCloseAction &Action)
{
if(Chart1->Align==alClient)
  {
  Chart1->Align=alNone;
  Chart1->Left=chrtL;
  Chart1->Top=chrtT;
  Chart1->Width=chrtW;
  Chart1->Height=chrtH;
  Action=caNone;
  return;
  }
if(fEditFormReg)
  {
  if(ID_YES==MessageBox(FormM->Handle, "  a, b, c.  ?", "!!!", MB_YESNO|MB_ICONWARNING))
  Button6->Click();
  }
}
//---------------------------------------------------------------------------
// 
void __fastcall TFormReg::Button1Click(TObject *Sender)
{
ShowMessage(String(
"      1  :\n\n\n")+
"1.        .\n\n"+
"2.          2   12  50  ().\n          ( ).\n\n"+
"3.         \"  \".   \" \"\n            (I  V).   \"\".\n         .\n\n"+
"4.        \"\".\n\n"+
"5.    (a, b, c)   .   \"  \".\n\n"+
"6.      .  .\n\n"
);
}
//---------------------------------------------------------------------------
//   
void __fastcall TFormReg::Button6Click(TObject *Sender)
{
SaveABC(CurBoxIndex);
LoadABC(CurBoxIndex);
fEditFormReg=false;
}
//---------------------------------------------------------------------------
//   
void __fastcall TFormReg::Button5Click(TObject *Sender)
{
LoadABC(CurBoxIndex);
}
//---------------------------------------------------------------------------
//  
void __fastcall TFormReg::Button7Click(TObject *Sender)
{
WORD d=(PWMmax-PWMmin)/(PWMnum-1);
for(int j=0; j<PWMnum; j++)
  {
  FormReg->StringGrid1->Cells[1][j+1]=j*d+PWMmin;
  FormReg->StringGrid1->Cells[2][j+1]=0;
  FormReg->StringGrid1->Cells[3][j+1]=0;
  FormReg->StringGrid1->Cells[4][j+1]=0;
  }
Edit1->Text=0;
Edit2->Text=0;
Edit3->Text=0;
fEditFormReg=true;
}
//---------------------------------------------------------------------------
void __fastcall TFormReg::StringGrid1SelectCell(TObject *Sender, int ACol, int ARow,  bool &CanSelect)
{
CurLn=ARow;
fEditFormReg=true;
}
//---------------------------------------------------------------------------
// 
void __fastcall TFormReg::Button4Click(TObject *Sender)
{
float k[3][4];
float x[1000];
float y[1000];
float a, b, c;
int i1=0, i2=PWMnum/2-1, i3=PWMnum-1;
if(i2==i1 || i2==i3){ShowMessage(" !!!"); return;}

for(int i=0; i<3; i++)
for(int j=0; j<4; j++)
  k[i][j]=0;
k[0][0]=PWMnum;
for(int i=0; i<PWMnum; i++)
  {
  x[i]=StringGrid1->Cells[2][i+1].ToInt();
  y[i]=ToDouble(StringGrid1->Cells[3][i+1]);
  k[0][1]+=x[i];
  k[0][2]+=x[i]*x[i];
  k[0][3]+=y[i];
  k[1][2]+=x[i]*x[i]*x[i];
  k[1][3]+=y[i]*x[i];
  k[2][2]+=x[i]*x[i]*x[i]*x[i];
  k[2][3]+=y[i]*x[i]*x[i];
  }
k[1][0]=k[0][1];
k[1][1]=k[0][2];
k[2][0]=k[0][2];
k[2][1]=k[1][2];

a=((k[0][3]/k[0][0]-k[2][3]/k[2][0])/(k[0][1]/k[0][0]-k[2][1]/k[2][0])-(k[0][3]/k[0][0]-k[1][3]/k[1][0])/(k[0][1]/k[0][0]-k[1][1]/k[1][0]))/
  ((k[0][2]/k[0][0]-k[2][2]/k[2][0])/(k[0][1]/k[0][0]-k[2][1]/k[2][0])-(k[0][2]/k[0][0]-k[1][2]/k[1][0])/(k[0][1]/k[0][0]-k[1][1]/k[1][0]));
b=((k[0][3]/k[0][0]-k[1][3]/k[1][0])-a*(k[0][2]/k[0][0]-k[1][2]/k[1][0]))/(k[0][1]/k[0][0]-k[1][1]/k[1][0]);
c=(k[0][3]-b*k[0][1]-a*k[0][2])/k[0][0];

Edit1->Text=FFF(a);
Edit2->Text=FFF(b);
Edit3->Text=FFF(c);
Button2->Click();
fEditFormReg=true;
}
//---------------------------------------------------------------------------
//  
void __fastcall TFormReg::Button2Click(TObject *Sender)
{
int x[1000];
float y[1000];
float a, b, c, f;
for(int i=0; i<PWMnum; i++)
  {
  x[i]=StringGrid1->Cells[2][i+1].ToInt();
  y[i]=ToDouble(StringGrid1->Cells[3][i+1]);
  }
a=ToDouble(Edit1->Text);
b=ToDouble(Edit2->Text);
c=ToDouble(Edit3->Text);
Chart1->Series[0]->Clear();
Chart1->Series[1]->Clear();
for(int i=0; i<PWMnum; i++)
  {
  f=x[i]*(a*x[i]+b)+c;
//  if(FormReg->ComboBox1->Text.Pos("")>0)f=x[i]*(a*x[i]+b)+c;
//  else f=b*x[i]+c;
  StringGrid1->Cells[4][i+1]=FormatFloat("0.000", f);
  Chart1->Series[0]->AddXY(x[i], y[i], "", clTeeColor); //      
  Chart1->Series[1]->AddXY(x[i], f, "", clTeeColor); 	//      
  }
}
//---------------------------------------------------------------------------
void __fastcall TFormReg::Edit1Exit(TObject *Sender)
{
fEditFormReg=true;
}
//---------------------------------------------------------------------------
void __fastcall TFormReg::Button3Click(TObject *Sender)
{
FormIN->ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall TFormReg::Chart1Click(TObject *Sender)
{
if(Chart1->Align==alNone)Chart1->Align=alClient;
}
//---------------------------------------------------------------------------
void __fastcall TFormReg::FormKeyPress(TObject *Sender, wchar_t &Key)
{
if(Key==VK_ESCAPE && Chart1->Align==alClient)
  {
  Chart1->Align=alNone;
  Chart1->Left=chrtL;
  Chart1->Top=chrtT;
  Chart1->Width=chrtW;
  Chart1->Height=chrtH;
  }
}
//---------------------------------------------------------------------------

