//---------------------------------------------------------------------------

#include <vcl.h>
#include <stdio.h>
#include <math.h>
#pragma hdrstop

#define String AnsiString
#include "UnitType.h"
#include "UnitM.h"
#include "h.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFormType *FormType;
bool fEditTyp=false;    //     
int nEditTyp=-1;        //      
bool fTypEdit=false;    //     
//---------------------------------------------------------------------------
__fastcall TFormType::TFormType(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
//     Mega[]
void LoadTypFromMega(void)
{
FormType->ListBox1->Clear();		//    EEPROM
//  
for(int i=0; i<NumTypEE; i++)
  {
  String s="";						//     
  for(int j=0; j<10; j++)
	{
	char c=char(Mega[0x4000+LenAkkEE*NumAkkEE+i*LenTypEE+j]);
	if(c>32)s+=c;else s+=' ';
	}
  FormType->ListBox1->Items->Add(s+" #"+IntToStr(i)+" EEPROM"); //   
  }
FormType->ListBox1->ItemIndex=0;
}
//---------------------------------------------------------------------------
//       
void SaveTyp(void)
{
if(!fEditTyp)return;
if(MessageBox(FormType->Handle, " ?", "!!!", MB_YESNO | MB_ICONQUESTION)!=ID_YES)return;

fTypEdit=true;
WORD a=0x4000+LenAkkEE*NumAkkEE+nEditTyp*LenTypEE;  //   
String N=(FormType->Edit1->Text+"          ").SubString(1, 10);

for(int i=0; i<10; i++)Mega[a+i]=N[i+1];
BYTE f1=0, f2=0;
f1+=FormType->CheckBox1->Checked?128:0;                //   1
f1+=FormType->CheckBox2->Checked?64:0;
f1+=FormType->CheckBox3->Checked?32:0;
f1+=FormType->CheckBox4->Checked?16:0;
f1+=FormType->CheckBox5->Checked?8:0;
f1+=FormType->CheckBox6->Checked?4:0;
f1+=FormType->CheckBox7->Checked?2:0;
f1+=FormType->CheckBox8->Checked?1:0;
Mega[a+10]=f1;

f2+=FormType->CheckBox9->Checked?128:0;                //   2
f2+=FormType->CheckBox10->Checked?64:0;
f2+=FormType->CheckBox11->Checked?32:0;
f2+=FormType->CheckBox12->Checked?16:0;
f2+=FormType->CheckBox13->Checked?8:0;
f2+=FormType->CheckBox14->Checked?4:0;
f2+=FormType->CheckBox15->Checked?2:0;
f2+=FormType->CheckBox16->Checked?1:0;
Mega[a+11]=f2;
Mega[a+12]=floor(ToDouble(FormType->Edit2->Text)*50.);
Mega[a+13]=floor(ToDouble(FormType->Edit3->Text)*50.);
Mega[a+14]=floor(ToDouble(FormType->Edit4->Text)*50.);
Mega[a+15]=floor(ToDouble(FormType->Edit5->Text)*50.);

Mega[a+16]=floor(ToDouble(FormType->Edit6->Text));
Mega[a+17]=floor(ToDouble(FormType->Edit7->Text));
Mega[a+18]=floor(ToDouble(FormType->Edit8->Text));
Mega[a+19]=floor(ToDouble(FormType->Edit9->Text));
Mega[a+20]=floor(ToDouble(FormType->Edit10->Text));
Mega[a+21]=floor(ToDouble(FormType->Edit11->Text));
Mega[a+22]=floor(ToDouble(FormType->Edit12->Text));
Mega[a+23]=floor(ToDouble(FormType->Edit13->Text));

Mega[a+24]=floor(ToDouble(FormType->Edit14->Text));
Mega[a+25]=floor(ToDouble(FormType->Edit15->Text));
Mega[a+26]=floor(ToDouble(FormType->Edit16->Text));
Mega[a+27]=floor(ToDouble(FormType->Edit17->Text));
Mega[a+28]=floor(ToDouble(FormType->Edit18->Text)*50.);
Mega[a+29]=floor(ToDouble(FormType->Edit19->Text));
Mega[a+30]=floor(ToDouble(FormType->Edit20->Text));

}
//---------------------------------------------------------------------------
//    
void ShowTyp(void)
{
SaveTyp();                        				//     
String x=FormType->ListBox1->Items->Strings[FormType->ListBox1->ItemIndex];//  
WORD a=0x4000+LenAkkEE*NumAkkEE+FormType->ListBox1->ItemIndex*LenTypEE;	//   

FormType->Edit1->Text=x.SubString(1, 10);

FormType->CheckBox1->Checked=Mega[a+10]&128;
FormType->CheckBox2->Checked=Mega[a+10]&64;
FormType->CheckBox3->Checked=Mega[a+10]&32;
FormType->CheckBox4->Checked=Mega[a+10]&16;
FormType->CheckBox5->Checked=Mega[a+10]&8;
FormType->CheckBox6->Checked=Mega[a+10]&4;
FormType->CheckBox7->Checked=Mega[a+10]&2;
FormType->CheckBox8->Checked=Mega[a+10]&1;

FormType->CheckBox9->Checked=Mega[a+11]&128;
FormType->CheckBox10->Checked=Mega[a+11]&64;
FormType->CheckBox11->Checked=Mega[a+11]&32;
FormType->CheckBox12->Checked=Mega[a+11]&16;
FormType->CheckBox13->Checked=Mega[a+11]&8;
FormType->CheckBox14->Checked=Mega[a+11]&4;
FormType->CheckBox15->Checked=Mega[a+11]&2;
FormType->CheckBox16->Checked=Mega[a+11]&1;

FormType->Edit2->Text=Mega[a+12]/50.;
FormType->Edit3->Text=Mega[a+13]/50.;
FormType->Edit4->Text=Mega[a+14]/50.;
FormType->Edit5->Text=Mega[a+15]/50.;

FormType->Edit6->Text=Mega[a+16];
FormType->Edit7->Text=Mega[a+17];
FormType->Edit8->Text=Mega[a+18];
FormType->Edit9->Text=Mega[a+19];
FormType->Edit10->Text=Mega[a+20];
FormType->Edit11->Text=Mega[a+21];
FormType->Edit12->Text=Mega[a+22];
FormType->Edit13->Text=Mega[a+23];

FormType->Edit14->Text=Mega[a+24];
FormType->Edit15->Text=Mega[a+25];
FormType->Edit16->Text=Mega[a+26];
FormType->Edit17->Text=Mega[a+27];
FormType->Edit18->Text=Mega[a+28]/50.;
FormType->Edit19->Text=Mega[a+29];
FormType->Edit20->Text=Mega[a+30];

fEditTyp=false;
}
//---------------------------------------------------------------------------
void __fastcall TFormType::Edit1Enter(TObject *Sender)
{
fEditTyp=true;
nEditTyp=ListBox1->ItemIndex;
}
//---------------------------------------------------------------------------
void __fastcall TFormType::FormShow(TObject *Sender)
{
LoadTypFromMega();
fEditTyp=false;
fTypEdit=false;
ListBox1->ItemIndex=0;
ShowTyp();
}
//---------------------------------------------------------------------------
void __fastcall TFormType::FormClose(TObject *Sender, TCloseAction &Action)
{
SaveTyp();
if(fTypEdit){if(MessageBox(FormType->Handle, "     .   ?", "!!!", MB_YESNO | MB_ICONQUESTION)!=ID_YES)Action=caNone;}
}
//---------------------------------------------------------------------------
void __fastcall TFormType::ListBox1Click(TObject *Sender)
{
if(ListBox1->ItemIndex>=0)ShowTyp();
}
//---------------------------------------------------------------------------
//    
void __fastcall TFormType::Button1Click(TObject *Sender)
{
SaveTyp();
FileToMega(DirBin+"BIN\\typ.bin", 0x4000+LenAkkEE*NumAkkEE, NumTypEE*LenTypEE);
LoadTypFromMega();
ListBox1->ItemIndex=0;
ShowTyp();
}
//---------------------------------------------------------------------------
//    
void __fastcall TFormType::Button3Click(TObject *Sender)
{
SaveTyp();		//          
MegaToFile(DirBin+"BIN\\typ.bin", 0x4000+LenAkkEE*NumAkkEE, NumTypEE*LenTypEE);
fEditTyp=false;	//  
fTypEdit=false;	//  
}
//---------------------------------------------------------------------------
//    EEPROM
void __fastcall TFormType::Button2Click(TObject *Sender)
{
SaveTyp();
DialogOpenCOM();
if(!fComOpend)return;				//   
ReadMemoryZU(0x4000+NumAkkEE*LenAkkEE, NumTypEE*LenTypEE, 16);
LoadTypFromMega();
ListBox1->ItemIndex=0;
ShowTyp();
}
//---------------------------------------------------------------------------
//    EEPROM
void __fastcall TFormType::Button4Click(TObject *Sender)
{
DialogOpenCOM();
if(!fComOpend)return;	//   
SaveTyp();				//          
Button4->Enabled=false; //      
int i=ListBox1->ItemIndex;
if(SaveMemoryZU(0x4000+NumAkkEE*LenAkkEE+i*LenTypEE, LenTypEE, LenTypEE))
  {
  fEditTyp=false;       //  
  fTypEdit=false;       //  
  }
Button4->Enabled=true;  //   ..   
}
//---------------------------------------------------------------------------

