#define PWM1TOP  0x1FFF             //    1  (1   2 ) ( 13 )
#define U_NotAnderstand 0xF0        //    (    )
#define U_OK            0xE1        //   
#define U_CANCEL        0xD2        //   
#define U_UP            0xC3        //      
#define U_DOWN          0xB4        //      
#define U_GiveMeADC     0xA5        //    ADC
#define U_GiveMeScr     0x96        //    
#define U_ReadMemory    0x5A        //    
#define U_WriteMemory   0x4B        //  
#define U_GO            0x3C        //  / 
#define U_VAR           0x2D        //  
#define U_Set           0x1F        //  
//---------------------------------------------------------------------------
#include "SCH.H"

extern String DirBin;
extern BYTE Mega[];
extern int COM;
extern long Timer;
extern int COMSpeed;
extern bool AutoComStart;
extern bool AutoReadEEPROM;
extern bool SaveComLog;
extern bool SaveFes;

extern bool fCH;
extern BYTE InBuf[];
extern BYTE iInBuf;
extern BYTE OutBuf[];
extern BYTE iOutBuf;
extern int rezFormCOM;
extern double Tc;
extern double V12;
extern sCH Ch1;
extern sCH Ch2;
extern String Prich[];
extern bool fComOpend;
//---------------------------------------------------------------------------
extern float R1z;
extern float R2z;
extern float kV12;
extern bool et1;
extern bool et2;
extern bool et3;
extern unsigned short etc1;
extern unsigned short etc2;
extern unsigned short etc3;
extern bool Volume;
extern BYTE MS[5];
extern int PWMnum;
extern WORD PWMmin;
extern WORD PWMmax;
extern int SplineType;
extern int SplinePow;
extern int CurLn;
//---------------------------------------------------------------------------
void SB(BYTE x);
BYTE CrcBuf8(BYTE *Sr, BYTE len);
double ToINT(String a);
void DialogOpenCOM(void);
bool SendCommandToCOM(void);
String IntToHex(WORD x);
String HexToStr(WORD x);
double ToDouble(String a);
void SaveIni(void);
String LoadVarFromZU(BYTE cod);
String GetPrm(String a, int x, char c);
bool SaveMemoryZU(WORD first, WORD length, WORD step);
bool ReadMemoryZU(WORD first, WORD length, WORD step);
void FileToMega(String name, WORD adr, WORD len);
void MegaToFile(String name, WORD adr, WORD len);
void PrnGrid(int c);
void SaveABC(int c);
void LoadABC(int c);
String FFF(float a);
//---------------------------------------------------------------------------
extern int NumAkkEE;
extern int LenAkkEE;
extern int NumTypEE;
extern int LenTypEE;
//---------------------------------------------------------------------------

