//---------------------------------------------------------------------------

#include <vcl.h>
#include <stdio.h>
#include <math.h>
#pragma hdrstop

#define String AnsiString
#include "UnitM.h"
#include "UnitA.h"
#include "h.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFormA *FormA;
bool fEditAkk=false;  //      
bool fAEdit=false;    //     
int nEditAkk=0;       //   
//---------------------------------------------------------------------------
__fastcall TFormA::TFormA(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
//     Mega[]
void LoadAkkFromMega(void)
{
FormA->ListBox1->Clear();                  //    EEPROM
FormA->ComboBox1->Clear();                 //    EEPROM
//  
for(int i=0; i<NumAkkEE; i++)              //   EEPROM
  {
  String s="";                             //     
  for(int j=0; j<10; j++)
	{
	char c=char(Mega[0x4000+i*LenAkkEE+j]);
	if(c>=32)s+=c;else s+='A';
	}
  String ss=s+" #"+IntToStr(i)+" EEPROM";
  FormA->ListBox1->Items->Add(ss);         //      EEPROM
  }
//  
for(int i=0; i<NumTypEE; i++)
  {
  String s="";                             //     
  for(int j=0; j<10; j++)
	{
	char c=char(Mega[0x4000+LenAkkEE*NumAkkEE+i*LenTypEE+j]);
	if(c>32)s+=c;else s+=' ';
	}
  FormA->ComboBox1->Items->Add(s+" #"+IntToStr(i)+" EEPROM");//   
  }
FormA->ListBox1->ItemIndex=0;
FormA->ComboBox1->ItemIndex=0;
}
//---------------------------------------------------------------------------
//       
void SaveAkk(void)
{
if(!fEditAkk)return;
if(MessageBox(FormA->Handle, " ?", "!!!", MB_YESNO | MB_ICONQUESTION)!=ID_YES)return;

fAEdit=true;
String N;
WORD a=0x4000+(nEditAkk*LenAkkEE);
N=(FormA->Edit1->Text+"          ").SubString(1, 10);
for(BYTE i=0; i<10; i++)Mega[a+i]=N[i+1];
Mega[a+10]=FormA->ComboBox1->ItemIndex;
Mega[a+11]=BYTE(int(floor(ToDouble(FormA->Edit2->Text))));
WORD x=WORD(int(floor(ToDouble(FormA->Edit3->Text)*10.)));
Mega[a+12]=x&0xff;
Mega[a+13]=(x>>8)&3;
Mega[a+14]=BYTE(int(floor(ToDouble(FormA->Edit4->Text))));
Mega[a+15]=BYTE(int(floor(ToDouble(FormA->Edit5->Text))));
}
//---------------------------------------------------------------------------
//    
void ShowAkk(void)
{
SaveAkk();
String x=FormA->ListBox1->Items->Strings[FormA->ListBox1->ItemIndex];
WORD a=0x4000+LenAkkEE*FormA->ListBox1->ItemIndex;

FormA->Edit1->Text=x.SubString(1, 10);
FormA->ComboBox1->ItemIndex=Mega[a+10];
FormA->Edit2->Text=Mega[a+11];
FormA->Edit3->Text=FormatFloat("0.00", ((Mega[a+13]&3)*256+Mega[a+12])/10.);
FormA->Edit4->Text=Mega[a+14];
FormA->Edit5->Text=Mega[a+15];
fEditAkk=false;
}
//---------------------------------------------------------------------------
void __fastcall TFormA::Edit1Enter(TObject *Sender)
{
fEditAkk=true;
nEditAkk=ListBox1->ItemIndex;
}
//---------------------------------------------------------------------------
void __fastcall TFormA::FormShow(TObject *Sender)
{
LoadAkkFromMega();
fEditAkk=false;
fAEdit=false;
ListBox1->ItemIndex=0;
ShowAkk();
}
//---------------------------------------------------------------------------
void __fastcall TFormA::FormClose(TObject *Sender, TCloseAction &Action)
{
SaveAkk();
if(fAEdit){if(MessageBox(FormA->Handle, "     .   ?", "!!!", MB_YESNO | MB_ICONQUESTION)!=ID_YES)Action=caNone;}
}
//---------------------------------------------------------------------------
void __fastcall TFormA::ListBox1Click(TObject *Sender)
{
if(ListBox1->ItemIndex>=0)ShowAkk();
}
//---------------------------------------------------------------------------
//    
void __fastcall TFormA::Button1Click(TObject *Sender)
{
SaveAkk();
FileToMega(DirBin+"BIN\\acc.bin", 0x4000, NumAkkEE*LenAkkEE);
LoadAkkFromMega();
ListBox1->ItemIndex=0;
ShowAkk();
}
//---------------------------------------------------------------------------
//    
void __fastcall TFormA::Button2Click(TObject *Sender)
{
SaveAkk();		//          
MegaToFile(DirBin+"BIN\\acc.bin", 0x4000, NumAkkEE*LenAkkEE);
fEditAkk=false;	//  
fAEdit=false;	//  
}
//---------------------------------------------------------------------------
//    EEPROM
void __fastcall TFormA::Button3Click(TObject *Sender)
{
SaveAkk();
DialogOpenCOM();
if(!fComOpend)return;				//   
ReadMemoryZU(0x4000, NumAkkEE*LenAkkEE, 16);
LoadAkkFromMega();
ListBox1->ItemIndex=0;
ShowAkk();
}
//---------------------------------------------------------------------------
//     EEPROM
void __fastcall TFormA::Button4Click(TObject *Sender)
{
DialogOpenCOM();
if(!fComOpend)return;	//   
SaveAkk();				//          
Button4->Enabled=false; //      
int i=ListBox1->ItemIndex;
if(SaveMemoryZU(0x4000+i*LenAkkEE, LenAkkEE, LenAkkEE))
  {
  fEditAkk=false;       //  
  fAEdit=false;         //  
  }
Button4->Enabled=true;  //   ..   
}
//---------------------------------------------------------------------------

